﻿namespace NetinaShop.Domain.Entities.Categories;

public partial class Category
{
    public static Category Create(string name, string description)
    {
        return new Category(name, description);
    }

    public void SetParent(Guid parentId)
    {
        ParentId = parentId;
    }

    public CategoryStorageFile AddFile(string name, string fileLocation, string fileName, bool isHeader, bool isPrimary, StorageFileType fileType)
    {
        var file = CategoryStorageFile.Create(name, fileLocation, fileName, isHeader, isPrimary, fileType, this.Id);
        Files.Add(file);
        return file;
    }
}

public partial class CategoryStorageFile
{
    public static CategoryStorageFile Create(string name, string fileLocation, string fileName, bool isHeader, bool isPrimary, StorageFileType fileType, Guid categoryId)
    {
        return new CategoryStorageFile(name, fileLocation, fileName, isHeader, isPrimary, fileType, categoryId);
    }
}