﻿namespace NetinaShop.Domain.Entities.Categories;
[AdaptTwoWays("[name]LDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget)]
[AdaptTo("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Projection)]
[GenerateMapper]
public partial class Category : ApiEntity
{
    public Category()
    {
        
    }

    public Category(string name, string description)
    {
        Name = name;
        Description = description;
    }
    public string Name { get; internal set; } = string.Empty;
    public string Description { get; internal set; } = string.Empty;

    public Guid ParentId { get; internal set; }
    public Category? Parent { get; internal set; }

    public List<Category> Children { get; internal set; } = new();
    public List<ProductCategory> Products { get; internal set; } = new();
    public List<CategoryStorageFile> Files { get; internal set; } = new();
}