﻿namespace NetinaShop.Domain.Entities.Products;

public partial class Product
{
    public static Product Create(string persianName, string englishName, string summery, string expertCheck, string tags, string warranty, Guid brandId)
    {
        return new Product(persianName, englishName, summery, expertCheck, tags, warranty, brandId);
    }

    public ProductCategory AddCategory(Guid categoryId)
    {
        var ent = ProductCategory.Create(categoryId, Id);
        Categories.Add(ent);
        return ent;
    }

    public ProductStorageFile AddFile(string name, string fileLocation, string fileName, bool isHeader, bool isPrimary, StorageFileType fileType)
    {
        var ent = ProductStorageFile.Create(name, fileLocation, fileName, isHeader, isPrimary, fileType, Id);
        Files.Add(ent);
        return ent;
    }

    public Specification AddSpecification(string title, string detail,string value, bool isFeature, Guid parentId)
    {
        var ent = Specification.Create(title, detail, value, isFeature, Id, parentId);
        Specifications.Add(ent);
        return ent;
    }
}

public partial class ProductCategory
{
    public static ProductCategory Create(Guid categoryId, Guid productId)
    {
        return new ProductCategory(categoryId, productId);
    }
}

public partial class ProductStorageFile
{
    public static ProductStorageFile Create(string name, string fileLocation, string fileName, bool isHeader,
        bool isPrimary, StorageFileType fileType, Guid productId)
    {
        return new ProductStorageFile(name, fileLocation, fileName, isHeader, isPrimary, fileType, productId);
    }
}

public partial class Review
{
    public static Review Create(string title, string comment, float rate, bool isBuyer, Guid productId, Guid userId)
    {
        return new Review(title, comment, rate, isBuyer, productId, userId);
    }

}

public partial class Specification
{
    public static Specification Create(string title,string value, string detail, bool isFeature, Guid productId, Guid parentId)
    {
        return new Specification(title, detail, value, isFeature, productId, parentId);
    }
}