﻿namespace NetinaShop.Domain.Entities.Products;
[AdaptTwoWays("[name]LDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget)]
[AdaptTo("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Projection)]
[GenerateMapper]
public partial class Product : ApiEntity
{
    public Product()
    {
        
    }

    public Product(string persianName, string englishName, string summery, string expertCheck, string tags, string warranty, Guid brandId)
    {
        PersianName = persianName;
        EnglishName = englishName;
        Summery = summery;
        ExpertCheck = expertCheck;
        Tags = tags;
        Warranty = warranty;
        BrandId = brandId;
    }
    public string PersianName { get; internal set; } = string.Empty;
    public string EnglishName { get; internal set; } = string.Empty;
    public string Summery { get; internal set; } = string.Empty;
    public string ExpertCheck { get; internal set; } = string.Empty;
    public string Tags { get; internal set; } = string.Empty;
    public string Warranty { get; set; } = string.Empty;

    public Guid BrandId { get; internal set; }
    public Brand? Brand { get; set; }

    public List<Specification> Specifications { get; internal set; } = new();
    public List<Review> Reviews { get; internal set; } = new();
    public List<ProductCategory> Categories { get; internal set; } = new();
    public List<ProductStorageFile> Files { get; internal set; } = new();
    public List<OrderProduct> OrderProducts { get; internal set; } = new();
}