﻿namespace NetinaShop.Domain.Entities.Warehouses;
[AdaptTwoWays("[name]LDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget)]
[AdaptTo("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Projection)]
[GenerateMapper]
public partial class Shipping : ApiEntity
{
    public Shipping()
    {
        
    }

    public Shipping(string title, string warehouseName, bool isFastShipping, bool isShipBySeller, bool isOriginalWarehouse)
    {
        Title = title;
        WarehouseName = warehouseName;
        IsFastShipping = isFastShipping;
        IsShipBySeller = isShipBySeller;
        IsOriginalWarehouse = isOriginalWarehouse;
    }

    public string Title { get; internal set; } = string.Empty;
    public string WarehouseName { get; internal set; } = string.Empty;
    public bool IsFastShipping { get; internal set; }
    public bool IsShipBySeller { get; internal set; }
    public bool IsOriginalWarehouse { get; internal set; }
}