using System;
using System.Linq.Expressions;
using NetinaShop.Domain.Dtos.SmallDtos;
using NetinaShop.Domain.Entities.Products;

namespace NetinaShop.Domain.Mappers
{
    public static partial class ProductCategoryMapper
    {
        public static ProductCategory AdaptToProductCategory(this ProductCategorySDto p1)
        {
            return p1 == null ? null : new ProductCategory()
            {
                CategoryId = p1.CategoryId,
                ProductId = p1.ProductId,
                Id = p1.Id
            };
        }
        public static ProductCategory AdaptTo(this ProductCategorySDto p2, ProductCategory p3)
        {
            if (p2 == null)
            {
                return null;
            }
            ProductCategory result = p3 ?? new ProductCategory();
            
            result.CategoryId = p2.CategoryId;
            result.ProductId = p2.ProductId;
            result.Id = p2.Id;
            return result;
            
        }
        public static ProductCategorySDto AdaptToSDto(this ProductCategory p4)
        {
            return p4 == null ? null : new ProductCategorySDto()
            {
                CategoryId = p4.CategoryId,
                CategoryName = p4.Category == null ? null : p4.Category.Name,
                ProductId = p4.ProductId,
                Id = p4.Id
            };
        }
        public static ProductCategorySDto AdaptTo(this ProductCategory p5, ProductCategorySDto p6)
        {
            if (p5 == null)
            {
                return null;
            }
            ProductCategorySDto result = p6 ?? new ProductCategorySDto();
            
            result.CategoryId = p5.CategoryId;
            result.CategoryName = p5.Category == null ? null : p5.Category.Name;
            result.ProductId = p5.ProductId;
            result.Id = p5.Id;
            return result;
            
        }
        public static Expression<Func<ProductCategory, ProductCategorySDto>> ProjectToSDto => p7 => new ProductCategorySDto()
        {
            CategoryId = p7.CategoryId,
            CategoryName = p7.Category.Name,
            ProductId = p7.ProductId,
            Id = p7.Id
        };
    }
}