﻿using NetinaShop.Domain.Entities.Categories;

namespace NetinaShop.Repository.Handlers.Categories;

public class DeleteCategoryCommandHandler : IRequestHandler<DeleteCategoryCommand, bool>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public DeleteCategoryCommandHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<bool> Handle(DeleteCategoryCommand request, CancellationToken cancellationToken)
    {

        var ent = await _repositoryWrapper.SetRepository<Category>().TableNoTracking
            .FirstOrDefaultAsync(c => c.Id == request.Id, cancellationToken);
        if (ent == null)
            throw new AppException("Category not found", ApiResultStatusCode.NotFound);
        _repositoryWrapper.SetRepository<Category>().Delete(ent);
        await _repositoryWrapper.SaveChangesAsync(cancellationToken);
        return true;
    }
}