﻿using NetinaShop.Domain.CommandQueries.Queries;
using NetinaShop.Domain.Dtos.SmallDtos;
using NetinaShop.Domain.Entities.Categories;

namespace NetinaShop.Repository.Handlers.Categories;

public class GetCategoriesQueryHandler : IRequestHandler<GetCategoriesQuery, List<CategorySDto>>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public GetCategoriesQueryHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<List<CategorySDto>> Handle(GetCategoriesQuery request, CancellationToken cancellationToken)
    {
        return await _repositoryWrapper.SetRepository<Category>().TableNoTracking.OrderByDescending(b => b.CreatedAt)
            .Skip(request.Page * 10).Take(10)
            .Select(CategoryMapper.ProjectToSDto)
            .ToListAsync(cancellationToken);
    }
}