﻿using NetinaShop.Domain.CommandQueries.Queries;
using NetinaShop.Domain.Entities.Categories;

namespace NetinaShop.Repository.Handlers.Categories;

public class GetCategoryQueryHandler : IRequestHandler<GetCategoryQuery, CategoryLDto>>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public GetCategoryQueryHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<CategoryLDto> Handle(GetCategoryQuery request, CancellationToken cancellationToken)
    {
        var ent = await _repositoryWrapper.SetRepository<Category>().TableNoTracking
            .Where(b => b.Id == request.Id)
            .Select(CategoryMapper.ProjectToLDto)
            .FirstOrDefaultAsync(cancellationToken);
        if (ent == null)
            throw new AppException("Category not found", ApiResultStatusCode.NotFound);
        return ent;
    }
}