﻿namespace NetinaShop.Repository.Handlers.Products;

public class GetProductsQueryHandler : IRequestHandler<GetProductsQuery, List<ProductSDto>>
{
    private readonly IRepositoryWrapper _repositoryWrapper;

    public GetProductsQueryHandler(IRepositoryWrapper repositoryWrapper)
    {
        _repositoryWrapper = repositoryWrapper;
    }
    public async Task<List<ProductSDto>> Handle(GetProductsQuery request, CancellationToken cancellationToken)
    {
        return await _repositoryWrapper.SetRepository<Product>().TableNoTracking
            .OrderByDescending(b => b.CreatedAt).Skip(request.Page * 10)
            .Take(10)
            .Select(ProductMapper.ProjectToSDto)
            .ToListAsync(cancellationToken);
    }
}